/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTCompatibility_h__
#define __RTCompatibility_h__ included

#ifndef __RTBoolean_h__
#include <RTBoolean.h>
#endif

#ifndef __RTCharacter_h__
#include <RTCharacter.h>
#endif

#ifndef __RTController_h__
#include <RTController.h>
#endif

#ifndef __RTEnumerated_h__
#include <RTEnumerated.h>
#endif

#ifndef __RTFrame_h__
#include <RTFrame.h>
#endif

#ifndef __RTLog_h__
#include <RTLog.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

#ifndef __RTReal_h__
#include <RTReal.h>
#endif

#ifndef __RTSequenceOf_h__
#include <RTSequenceOf.h>
#endif

#ifndef __RTString_h__
#include <RTString.h>
#endif

#ifndef __RTTime_h__
#include <RTTime.h>
#endif

#ifndef __RTTiming_h__
#include <RTTiming.h>
#endif

#if RTS_COMPATIBLE <= 520
    // For compatibility with Developer version 5.2.

    typedef RTController OTRTS;

    typedef RTProtocol   RTAsyncCommSAP;
    typedef RTProtocol   RTReplicatedAsyncSAP;
    typedef RTProtocol   RTReplicatedLayerSAP;
    typedef RTProtocol   RTLayerSAP;
    typedef RTProtocol   RTLayerSPP;

    typedef RTDataObject Null;

    typedef RTCharacter  Character;
    typedef RTEnumerated Enumerated;
    typedef RTInteger    Integer;
#if RTREAL_INCLUDED
    typedef RTReal       Real;
#endif
    typedef RTSequence   Sequence;
    typedef RTSequenceOf SequenceOf;
    typedef RTString     String;
    typedef RTTime       Time;
#endif // RTS_COMPATIBLE <= 520

#if RTS_COMPATIBLE <= 600
    // For compatibility with RoseRT version 6.0.

    typedef RTProtocol   RTEndPortRef;
    typedef Frame::Base  RTFrameSAP;
    typedef Log::Base    RTLogSAP;
    typedef Timing::Base RTTimerSAP;
#endif // RTS_COMPATIBLE <= 600

#if RTS_COMPATIBLE <= 640
    // For compatibility with RoseRT version 6.4.

#define RTDATA rtdata

#define RETURN return

//lint -save -e773

#define BLOCK_OF( type )   (type *)(void *)*(RTByteBlock *)
#define POINTER_OF( type ) (type *)(void *)*(RTPointer   *)

//lint -restore

#define SEND_PTR( ptr )     ( (const void *)(ptr) )
#define RECEIVE_PTR( type ) ( (type *)getMsg()->getData() )

#define SEND_SCALAR( value )   ( (const void *)(value) )
#define RECEIVE_SCALAR( type ) ( (type)(void *)getMsg()->getData() )

#define SEND_EXT( value )      ( new_RTTypedValue( (value) ) )
#define RECEIVE_EXT( type )    ( *(const type *)getMsg()->getData() )

#endif // RTS_COMPATIBLE <= 640

#endif // __RTCompatibility_h__
