/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTDictionary_h__
#define __RTDictionary_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTAssociation_h__
#include <RTAssociation.h>
#endif

class RTDictionary
{
protected:
    unsigned            _size;
    unsigned            _used;
    RTAssociation     * _contents;

    RTAssociation     * find( const char * ) const;

public:
    explicit            RTDictionary( unsigned initialSize = 0 );
			RTDictionary( const RTDictionary & );
			~RTDictionary( void );

    RTDictionary      & operator=( const RTDictionary & );

    RTS_INLINE unsigned size( void ) const;

    int                 atPut( const char * key, void * value );
    RTS_INLINE int      add( const RTAssociation & );
    int                 remove( const char * key );
    void              * operator[]( const char * key ) const;

    static unsigned     hash( const char *, unsigned );

    class Iterator
    {
	friend class RTDictionary;
    private:
	unsigned _index;

    public:
	RTS_INLINE      Iterator( void );
	RTS_INLINE      ~Iterator( void );
	RTS_INLINE void reset( void );
    };

    const RTAssociation * iterate( Iterator & ) const;
};

#if RTS_INLINES
#include <RTDictionary.inl>
#endif

#endif // __RTDictionary_h__
