/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTPriority_h__
#define __RTPriority_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTInteger_h__
#include <RTInteger.h>
#endif

enum
{
    Synchronous = 0,
    System      = 1,
    Panic       = 2,
    High        = 3,
    General     = 4,
    Low         = 5,
    Background  = 6
};

enum
{
    OTRTS_NUMPRIO = ( Background - Synchronous + 1 )
};

class RTPriority : public RTInteger
{
public:
    static RTS_INLINE int           isValid( int );
    static const char             * name( int );
    static int                      lookup( const char * );

    enum { Default = General };

				    RTPriority( int = Default ); //lint !e1931
				    RTPriority( const RTPriority & );
    virtual                         ~RTPriority( void );

    RTS_INLINE const char         * name( void ) const;

    virtual const RTObject_class  * getClassData( void ) const;
    static  const RTObject_class    classData;

#define RTType_RTPriority ( RTPriority::classData )
};

struct RTTypedValue_RTPriority
{
    const void           * data;
    const RTObject_class * type;

    RTS_INLINE RTTypedValue_RTPriority( const RTPriority     & ); //lint !e1931
    RTS_INLINE RTTypedValue_RTPriority( const RTPriority     &,
					const RTObject_class * );
}; //lint !e1712

#if RTS_INLINES
#include <RTPriority.inl>
#endif

#endif // __RTPriority_h__
