/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSymmetricSignal_h__
#define __RTSymmetricSignal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTPriority_h__
#include <RTPriority.h>
#endif

#ifndef __RTProtocol_h__
#include <RTProtocol.h>
#endif

// It is common to make temporaries of this struct.
//lint -esym(1901,RTSymmetricSignal)

struct RTSymmetricSignal
{
    // general application use
    RTS_INLINE int purge      ( void );
    RTS_INLINE int purgeAt    ( int index );
    RTS_INLINE int recall     (            int front = 0 );
    RTS_INLINE int recallAt   ( int index, int front = 0 );
    RTS_INLINE int recallAll  (            int front = 0 );
    RTS_INLINE int recallAllAt( int index, int front = 0 );

    RTS_INLINE int invoke  (            RTMessage * replyBuffers );
    RTS_INLINE int invokeAt( int index, RTMessage * replyBuffer );
    RTS_INLINE int reply   ( void );
    RTS_INLINE int send    (            int priority = General );
    RTS_INLINE int sendAt  ( int index, int priority = General );

    // for use by run-time services library only
    RTS_INLINE RTSymmetricSignal( RTProtocol *, int signal_in, int signal_out );

    RTProtocol * _port;
    int          _in_signal;
    int          _out_signal;
}; //lint !e1712

#if RTS_INLINES
#include <RTSymmetricSignal.inl>
#endif

#endif // __RTSymmetricSignal_h__
