/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTMessage.h>
#include <RTProtocol.h>

void RTActor::unexpectedMessage( void )
{
    RTDiagStream & out = RTDiag::out();

    out.lock();

    if( getReference() != (RTActorRef *)0 )
	out << getName() << "(" << index() << ")";
    else
	out << getTypeName();

    out << "@" << getCurrentStateString() << " received unexpected message: ";

    const RTMessage * m = getMsg();

    if( m == (const RTMessage *)0 )
	out << "No message pointer!\n";
    else
    {
	RTProtocol * port = m->sap();

	if( port != (RTProtocol *)0 )
	{
	    const char * portName = port->getName();

	    if( portName != (const char *)0 )
		out << portName << "%";

	}

	const char * name = m->getSignalName();

	if( name == (const char *)0 )
	    out << "?(" << m->getSignal() << ")";
	else
	    out << name;

	out << " data: ";

#if OBJECT_ENCODE
	const RTObject_class * type = m->getType();

	if( type != (const RTObject_class *)0 )
	    out.write( m->data, type );
	else
#endif
	    out << m->data;

	out << "\n";
    }
    out.flush();
    out.unlock();
}
