/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTGlobalSignal.h>
#include <RTProtocolDescriptor.h>
#include <RTSignalDescriptor.h>
#include <RTSpecialSignals.h>

static const RTSignalDescriptor RTControl_Signals[] =
{
    { "ack",            (const RTObject_class *)0, RTAckSignal }
  , { "destroy",        (const RTObject_class *)0, RTDestroySignal }
  , { "initialize",     (const RTObject_class *)0, RTInitSignal }
  , { "interrupt",      (const RTObject_class *)0, RTInterruptSignal }
  , { "pendingTimeout", (const RTObject_class *)0, RTPendingTimeoutSignal }
#if OBSERVABLE
  , { "probe",          (const RTObject_class *)0, RTProbeSignal }
#endif
  , { "start",          (const RTObject_class *)0, RTStartSignal }
  , { "stop",           (const RTObject_class *)0, RTStopSignal }
  , { "timeout",        (const RTObject_class *)0, RTTimeoutSignal }
  , { "wakeup",         (const RTObject_class *)0, RTWakeupSignal }
};

const RTProtocolDescriptor RTControl_Conjugate_Class =
{
    (const RTProtocolDescriptor *)0,
    &RTControl_Protocol_Class,
    "RTControl",
    (RTVersionId)0,
    0, (const RTSignalDescriptor *)0
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal
  , &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTProtocolDescriptor RTControl_Protocol_Class =
{
    (const RTProtocolDescriptor *)0,
    &RTControl_Conjugate_Class,
    "RTControl",
    (RTVersionId)0,
    sizeof( RTControl_Signals ) / sizeof( RTControl_Signals[ 0 ] ),
	RTControl_Signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal
  , &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};
