/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorRef.h>
#include <RTComponentDescriptor.h>
#include <RTDiag.h>
#include <RTImportList.h>



int RTActorRef::deport( RTActor * actor, RTImportList * entry, RTController * initiator )
{

    RTAssert( actor != (RTActor *)0 );

    if( entry->used.actor != actor || entry->used.reference != this )
    {
	initiator->setError( RTController::badIndex,
			     RTController::FrameDeport,
			     this,
			     (const void *)0 );
	return 0;
    }

    int            replication = _info->replication;
    RTImportList * first;

    if( replication == 1 )
	first = (RTImportList *)_contents;
    else
    {
	RTImportList::Unused * head = (RTImportList::Unused *)_contents;

	first = (RTImportList *)(void *)&head[ 1 ];
    }

    int index = entry - first; //lint !e946 !e947

    if( index < 0 || index >= replication )
    {
	initiator->setError( RTController::badIndex,
			     RTController::FrameDeport,
			     this,
			     (const void *)0 );
	return 0;
    }

    remove( index );

    return 1;
}

