/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>

int RTAsciiDecoding::get_long( long & value )
{
    const long max_div_10 =              ( ~0UL >> 1 )   / 10UL;
    const long max_mod_10 =              ( ~0UL >> 1 )   % 10UL;
    const long min_div_10 = - (long)( ( ~( ~0UL >> 1 ) ) / 10UL );
    const long min_mod_10 = - (long)( ( ~( ~0UL >> 1 ) ) % 10UL );

    enum { someDigits = 1, overflow = 2 };

    long tmp    = 0L;
    int  status = 0;
    bool pos    = true;
    char byte;

    if( getNonWhite( byte ) == 0 )
	return 0;

    if( byte == '-' )
    {
	pos = false;
	if( getByte( byte ) == 0 )
	    return 0;
    }

    do
    {
	if( '0' <= byte && byte <= '9' )
	{
	    status |= someDigits;

	    long digit = (long)( byte - '0' );

	    if( pos )
	    {
		if( tmp < max_div_10 )
		{
		    // no possibility of overflow
		}
		else if( tmp > max_div_10 || digit > max_mod_10 )
		{
		    status |= overflow;
		}
	    }
	    else
	    {
		digit = - digit;

		if( tmp > min_div_10 )
		{
		    // no possibility of overflow
		}
		else if( tmp < min_div_10 || digit < min_mod_10 )
		{
		    status |= overflow;
		}
	    }

	    tmp *= 10L;
	    tmp += digit;
	}
	else
	{
	    ungetByte( byte );
	    break;
	}
    }
    while( getByte( byte ) != 0 );

    if( status != someDigits )
	return 0;

    value = tmp;

    return 1;
}
