/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>

int RTAsciiDecoding::get_opaque( int & value_size, char * & value )
{
    int    size;
    char * data;

    if( get_int( size ) == 0 )
	return 0;

    if( size < 0 )
	return 0;

    if( size == 0 )
	data = (char *)0;
    else
    {
	data = new char [ (unsigned)size ];

	if( data == (char *)0 )
	    return 0;

	char * cursor = data;

	for( int required = size; --required >= 0; )
	{
	    int ch;

	    if( get_int( ch ) != 0 && 0 <= ch && ch <= 0xFF )
		*cursor++ = (char)ch;
	    else
	    {
		delete [] data;
		return 0;
	    }
	}
    }

    value_size = size;
    value      = data;

    return 1;
}
