/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTCachedString.h>
#include <RTMemoryUtil.h>

RTCachedString & RTCachedString::operator=( const RTCachedString & rhs )
{
    lock();

    if( this != &rhs && _entry != rhs._entry )
    {
	unlink( _entry );
	link( _entry = rhs._entry );
    }

    unlock();

    return *this;
}

RTCachedString & RTCachedString::operator=( const char * string )
{
    lock();

    if( _entry == (Entry *)0 )
    {
	if( string == (const char *)0 )
	{
	    // do nothing: both are nil
	}
	else
	{
	    _entry = add( string );
	}
    }
    else
    {
	if( string == (const char *)0 )
	{
	    unlink( _entry );
	    _entry = (Entry *)0;
	}
	else if( RTMemoryUtil::strcmp( *this, string ) == 0 )
	{
	    // no change
	}
	else
	{
	    unlink( _entry );
	    _entry = add( string );
	}
    }

    unlock();

    return *this;
}
