/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTCharacter.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTnew.h>

static RTDataObject * _access( RTCharacter * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTCharacter;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTCharacter( *(const RTCharacter *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    RTCharacter * data = (RTCharacter *)target;

    return coding->get_char( data->value );
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    const RTCharacter * data = (const RTCharacter *)source;

    return coding->put_char( data->value );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTCharacter",
	(RTFieldOffset)0,
	&RTCharacter::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTCharacter::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTCharacter",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTCharacter ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTCharacter_installer( RTType_RTCharacter );
#endif

const RTObject_class * RTCharacter::getClassData( void ) const
{
    return &RTCharacter::classData;
}
