/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTMutex.h>

void RTController::acceptIncoming( void )
{
    short bits;
    short priority;

    _mutex->enter();

    if( (bits = incomingBits) != 0 )
    {
	internalBits |= bits;
	incomingBits  = 0;

	do
	{
	    priority = topPriority[ bits ];
	    bits ^= (short)( 1 << priority );
#if RTS_COUNT
	    counts.messagesAllocated += (unsigned)incomingQ[ priority ].size();
#endif
	    internalQ[ priority ].appendFrom( incomingQ[ priority ] );
	}
	while( bits != 0 );
    }

    _mutex->leave();
}
