/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTTimerNode.h>

RTTimerNode * RTController::newTimerNode( void )
{
#if USE_THREADS
    _mutex->enter();
#endif

    RTTimerNode * value = freeTimerList;

    if( value == (RTTimerNode *)0 )
	value = new RTTimerNode( this );
    else
    {
	freeTimerList = value->next;
	--freeTimerListSize;
    }

#if USE_THREADS
    _mutex->leave();
#endif

    return value;
}
