/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTDiag.h>

//lint -save -e1738 -esym(1926,RTController::internalQ,RTController::incomingQ)

RTController::RTController( const RTController & )
    : RTJob()
    , _name            ( (const char           *)0 )
#if OTRTSDEBUG != DEBUG_NONE
    , _debugger        ( (RTDebugger           *)0 )
    , _prev            ( (RTController         *)0 )
    , _next            ( (RTController         *)0 )
    , _state           (                execSystem )
#endif
    , errorNumber      (                        ok )
#if USE_THREADS
    , _sync            ( (RTSyncObject         *)0 )
#endif
    , internalBits     (                         0 )
#if USE_THREADS
    , incomingBits     (                         0 )
#endif
    , freeList         ( (RTMessage            *)0 )
    , freeListSize     (                         0 )
    , freeTimerList    ( (RTTimerNode          *)0 )
    , freeTimerListSize(                         0 )
    , replyBuffer      ( (RTMessage            *)0 )
#if ! DEFER_IN_ACTOR
    , deferredQ        (                           )
#endif
#if RTS_COUNT
    , counts           (                           )
#endif
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTController( const RTController & )'" );
}

//lint -restore

RTController & RTController::operator=( const RTController & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTController::operator=( const RTController & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
