/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTCounts.h>
#include <RTDiag.h>

//lint -save -esym(1927,RTCounts::messagesDelivered)

RTCounts::RTCounts( const RTCounts & )
    : actorsIncarnated     ( 0U )
    , actorsDestroyed      ( 0U )
    , portsIncarnated      ( 0U )
    , portsDestroyed       ( 0U )
    , messagesAllocated    ( 0U )
    , peakMessagesAllocated( 0U )
    , messagesInvoked      ( 0U )
    , messagesDropped      ( 0U )
    , timersStarted        ( 0U )
    , timersExpired        ( 0U )
    , timersCancelled      ( 0U )
{
    for( int i = 0; i < OTRTS_NUMPRIO; ++i )
	messagesDelivered[ i ] = 0U;

    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTCounts( const RTCounts & )'" );
}

//lint -restore

RTCounts & RTCounts::operator=( const RTCounts & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTCounts::operator=( const RTCounts & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
