/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebugger.h>
#include <RTDiag.h>

#if OBSERVABLE
#include <RTinet.h>
#endif

//lint -save -e1738 -esym(1927,RTDebugger::traceLevel)

RTDebugger::RTDebugger( const RTDebugger & )
    : RTJob()
    , mode          (            Halted )
    , tasks         ( (RTController *)0 )
    , input         (                   )
    , step_count    (                0U )
    , freeList      ( (RTMessage    *)0 )
    , freeListSize  (                0U )
#if OBSERVABLE
    , probes        (                   )
    , parkedProbes  (                   )
    , nrParkedProbes(                 0 )
    , lastTimestamp (            0L, 0L )
    , zeroTimeBase  (            0L, 0L )
    , listener      (                   )
    , ioMonitor     ( (RTIOMonitor  *)0 )
#if USE_THREADS
    , _udp          (    INET_NO_SOCKET )
    , _udp_port     (                 0 )
#ifdef TARGET_PSOS
    , _trigger      ( (void         *)0 )
#endif
#endif // USE_THREADS
    , eventHead     ( (RTEventInfo  *)0 )
    , eventTail     ( (RTEventInfo  *)0 )
    , sockets       (                   )
    , observers     (                   )
#endif // OBSERVABLE
{
    for( int i = 0; i < TraceAll; ++i )
	traceLevel[ i ] = DEBUG_NONE;

    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTDebugger( const RTDebugger & )'" );
}

//lint -restore

RTDebugger & RTDebugger::operator=( const RTDebugger & )
{
    RTDiag::panic( "Unavailable method called:\n"
		   "    'RTDebugger::operator=( const RTDebugger & )'" );

    //lint -unreachable
    return *this;
} //lint !e1529
