/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDictionary.h>
#include <RTMemoryUtil.h>

RTAssociation * RTDictionary::find( const char * key ) const
{
    if( key == (const char *)0 )
	return (RTAssociation *)0; // keys are never nil

    if( _used == 0U )
	return (RTAssociation *)0; // this dictionary is empty

    unsigned        index = hash( key, _size );
    RTAssociation * assoc = &_contents[ index ];
    unsigned        tests = 0U;

    for(;;)
    {
	if( assoc->key != (char *)0   &&
	    assoc->key != (char *)assoc &&
	    RTMemoryUtil::strcmp( assoc->key, key ) == 0 )
	{
	    return assoc;
	}
	
	if( assoc->key == (char *)0 )
	    break;

	if( ++tests == _size )
	    break; // we looked everywhere

	if( ++index == _size )
	{
	    index = 0U;
	    assoc = _contents;
	}
	else
	    ++assoc;
    }

    return (RTAssociation *)0; // key not found
}
