/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTException.h>
#include <RTGlobalSignal.h>
#include <RTSignalDescriptor.h>

static const RTSignalDescriptor Exception_Signals[] =
{
    {
	"arithmeticError",
	(const RTObject_class *)0,
	Exception::Base::rti_arithmeticError
    },
    {
	"error",
	(const RTObject_class *)0,
	Exception::Base::rti_error
    },
    {
	"notFoundError",
	(const RTObject_class *)0,
	Exception::Base::rti_notFoundError
    },
    {
	"notUnderstoodError",
	(const RTObject_class *)0,
	Exception::Base::rti_notUnderstoodError
    },
    {
	"serviceAccessError",
	(const RTObject_class *)0,
	Exception::Base::rti_serviceAccessError
    },
    {
	"streamError",
	(const RTObject_class *)0,
	Exception::Base::rti_streamError
    },
    {
	"subclassResponsibilityError",
	(const RTObject_class *)0,
	Exception::Base::rti_subclassResponsibilityError
    },
    {
	"timeSliceError",
	(const RTObject_class *)0,
	Exception::Base::rti_timeSliceError
    },
    {
	"userError",
	(const RTObject_class *)0,
	Exception::Base::rti_userError
    }
};

const RTProtocolDescriptor Exception::Base::rt_class =
{
    (const RTProtocolDescriptor *)0,
    &rt_class,
    "Exception",
    (RTVersionId)0,
    sizeof( Exception_Signals ) / sizeof( Exception_Signals[ 0 ] ),
    Exception_Signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal
  , &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};
