/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>

void RTIOMonitor::remove( int fd, int bits )
{
    if( fd < 0 || (bits &= RequestMask) == 0 )
	return;

    unsigned lo;
    unsigned hi;

    // Entries are sorted: do binary search.
    for( lo = 0U, hi = _used; lo < hi; )
    {
	unsigned   mid   = ( lo + hi ) >> 1;
	Entry    * entry = &_entries[ mid ];

	if( entry->fd == (unsigned)fd )
	{
	    entry->bits &= bits ^ RequestMask;

	    if( entry->bits == 0 ) // remove useless entries
		for( --_used; mid < _used; ++entry, ++mid )
		    entry[ 0 ] = entry[ 1 ];

	    return;
	}

	if( entry->fd > (unsigned)fd )
	    hi = mid;
	else
	    lo = mid + 1U;
    }
}
