/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTBindingEnd.h>
#include <RTController.h>
#include <RTLayerConnector.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>
#include <RTProtocolDescriptor.h>

void RTLayerConnector::bind( RTController * context,
			     RTBindingEnd & end1,
			     RTBindingEnd & end2,
			     CheckOption    check )
{
#if RTTYPECHECK_PROTOCOL == RTTYPECHECK_DONT
    (void)check;
#else
    if( check != CheckedAlready )
    {
	const RTProtocolDescriptor * proto1 = end1.port->_info->protocol;
	const RTProtocolDescriptor * proto2 = end2.port->_info->protocol;

	switch( proto1->compare( proto2 ) )
	{
	default:
	case RTProtocolDescriptor::badSignal:
	    context->setError( RTController::protocolSignal,
			       RTController::LayerBind,
			       &end1,
			       &end2 );
	    return;

	case RTProtocolDescriptor::badType:
	    context->setError( RTController::protocolType,
			       RTController::LayerBind,
			       &end1,
			       &end2 );
#if RTTYPECHECK_PROTOCOL == RTTYPECHECK_WARN
	    break;
#else
	    return;
#endif

	case RTProtocolDescriptor::ok:
	    break;
	}
    }
#endif // RTTYPECHECK_PROTOCOL != RTTYPECHECK_DONT

    end1.port->bindAt( end1.index, end2, context );
}
