/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLocalConnector.h>

void RTLocalConnector::SppNode::remove( RTController * context,
					SapNode      * entry )
{
    if( saps == entry )
    {
	saps = entry->next;

	if( saps == entry )
	{
	    saps = (SapNode *)0;

	    if( spp == (RTProtocol *)0 )
	    {
		// Use the registered name of the SAP as
		// the SPP may never have been published.
		const char * sap_name = parseName( entry->getRegisteredName() );

		(void)connector->db.remove( sap_name );
		return;
	    }
	}
    }

    entry->prev->next = entry->next;
    entry->next->prev = entry->prev;

    if( pending != (Request *)0 && spp != (RTProtocol *)0 )
	connectAll( context );
}
