/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTFieldDescriptor.h>
#include <RTFieldOffset.h>
#include <RTObject_class.h>

void RTarray_copy( const RTObject_class * type,
		   void                 * target,
		   const void           * source )
{
    RTAssert( type->_fields->modifier == (const RTTypeModifier *)0 );

    int                    count   = type->_num_fields;
    const RTObject_class * element = type->_fields->type;
    RTFieldOffset          stride  = element->_size;

    while( --count >= 0 )
    {
	element->copy( target, source );

	target = RTObjectOf     ( void, stride, target );
	source = RTConstObjectOf( void, stride, source );
    }
}
