/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTFieldDescriptor.h>
#include <RTFieldOffset.h>
#include <RTObject_class.h>

void RTarray_destroy( const RTObject_class * type, void * target )
{
    RTAssert( type->_fields->modifier == (const RTTypeModifier *)0 );

    int                    count   = type->_num_fields;
    const RTObject_class * element = type->_fields->type;
    RTFieldOffset          stride  = element->_size;

    target = RTObjectOf( void, stride * (RTFieldOffset)count, target );

    while( --count >= 0 )
    {
	target = RTObjectOf( void, - stride, target );

	(*element->_destroy_func)( element, target );
    }
}
