/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void bool_init( const RTObject_class *, void * target )
{
    *(bool *)target = false;
}

static void bool_copy( const RTObject_class *,
		       void                 * target,
		       const void           * source )
{
    *(bool *)target = *(const bool *)source;
}

#if OBJECT_DECODE
static int bool_decode( const RTObject_class *,
			void                 * target,
			RTDecoding           * coding )
{
    return coding->get_bool( *(bool *)target );
}
#endif

#if OBJECT_ENCODE
static int bool_encode( const RTObject_class *,
			const void           * source,
			RTEncoding           * coding )
{
    return coding->put_bool( *(const bool *)source );
}
#endif

const RTObject_class RTType_bool =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "bool",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( bool ),
    bool_init,
    bool_copy,
#if OBJECT_DECODE
    bool_decode,
#endif
#if OBJECT_ENCODE
    bool_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller bool_installer( RTType_bool );
#endif
