/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void float_init( const RTObject_class *, void * target )
{
    *(float *)target = 0.0f;
}

static void float_copy( const RTObject_class *,
			void                 * target,
			const void           * source )
{
    *(float *)target = *(const float *)source;
}

#if OBJECT_DECODE
static int float_decode( const RTObject_class *,
			 void                 * target,
			 RTDecoding           * coding )
{
    return coding->get_float( *(float *)target );
}
#endif

#if OBJECT_ENCODE
static int float_encode( const RTObject_class *,
			 const void           * source,
			 RTEncoding           * coding )
{
    return coding->put_float( *(const float *)source );
}
#endif

const RTObject_class RTType_float =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "float",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( float ),
    float_init,
    float_copy,
#if OBJECT_DECODE
    float_decode,
#endif
#if OBJECT_ENCODE
    float_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller float_installer( RTType_float );
#endif
