/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void ushort_init( const RTObject_class *, void * target )
{
    *(unsigned short *)target = 0U;
}

static void ushort_copy( const RTObject_class *,
			 void                 * target,
			 const void           * source )
{
    *(unsigned short *)target = *(const unsigned short *)source;
}

#if OBJECT_DECODE
static int ushort_decode( const RTObject_class *,
			  void                 * target,
			  RTDecoding           * coding )
{
    return coding->get_ushort( *(unsigned short *)target );
}
#endif

#if OBJECT_ENCODE
static int ushort_encode( const RTObject_class *,
			  const void           * source,
			  RTEncoding           * coding )
{
    return coding->put_ushort( *(const unsigned short *)source );
}
#endif

const RTObject_class RTType_RTushort =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "RTushort",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( unsigned short ),
    ushort_init,
    ushort_copy,
#if OBJECT_DECODE
    ushort_decode,
#endif
#if OBJECT_ENCODE
    ushort_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller RTushort_installer( RTType_RTushort );
#endif
