/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTController.h>
#include <RTProtocol.h>
#include <RTRecallFilter.h>

int RTProtocol::recallAllFront( void )
{
    RTActor      * owner      = getOwner();
    RTController * controller = owner->context();
    int            count;

    controller->trace( RTController::CommRecallAll, this, (const void *)0 );

  {
    RTRecallFilter filter( controller, this, RTRecallFilter::Front );

#if DEFER_IN_ACTOR
    count = owner     ->deferredQ.filterAll( filter );
#else
    count = controller->deferredQ.filterAll( filter );
#endif
  }

    return count;
}
