/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTSignal.h>
#include <RTnew.h>

static RTInteger * _access( RTSignal * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTSignal;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTSignal( *(const RTSignal *)source );
}

static const RTFieldDescriptor _fields[] =
{
    {
	"RTSignal",
	(RTFieldOffset)0,
	&RTSignal::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTSignal::classData =
{
    &RTType_RTInteger,
    (RTSuperAccessFunction)_access,
    "RTSignal",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTSignal ),
    _init,
    _copy,
#if OBJECT_DECODE
    RTinherit_decode,
#endif
#if OBJECT_ENCODE
    RTinherit_encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTSignal_installer( RTType_RTSignal );
#endif

const RTObject_class * RTSignal::getClassData( void ) const
{
    return &RTSignal::classData;
}
