/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTString.h>
#include <RTnew.h>

static RTDataObject * _access( RTString * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTString;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTString( *(const RTString *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    char * Contents;

    if( coding->get_string( Contents ) == 0 )
	return 0;
    else
    {
	RTString * string = (RTString *)target;

	delete [] string->Contents;

	string->Contents = Contents;

	return 1;
    }
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    const RTString * data = (const RTString *)source;

    return coding->put_string( *data );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTString",
	(RTFieldOffset)0,
	&RTString::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTString::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTString",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTString ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTString_installer( RTType_RTString );
#endif

const RTObject_class * RTString::getClassData( void ) const
{
    return &RTString::classData;
}
