/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTIOMonitor.h>
#include <RTTcpSocket.h>
#include <RTinet.h>
#include <RTtcp.h>

int RTTcpSocket::acceptFrom( const RTTcpSocket & source )
{
    if( _sd != INET_NO_SOCKET || source._sd == INET_NO_SOCKET )
	return 0;

    RTinet_address address;
    RTinet_port    port;

    if( (_sd = RTinet_accept( source._sd, &address, &port )) == INET_NO_SOCKET )
	return 0;

    _state = Established;

    if( _monitor != (RTIOMonitor *)0 )
	// we want to know when this socket is readable
	_monitor->add( _sd, RTIOMonitor::CanRead );

    return 1;
}
