/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTTime.h>
#include <RTnew.h>

static RTSequence * _access( RTTime * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTTime;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTTime( *(const RTTime *)source );
}

const RTFieldDescriptor RTTime::fieldData[] =
{
    {
	"hours",
	RTOffsetOf( RTTime, hours ),
	&RTType_RTInteger,
	(const RTTypeModifier *)0
    },
    {
	"minutes",
	RTOffsetOf( RTTime, minutes ),
	&RTType_RTInteger,
	(const RTTypeModifier *)0
    },
    {
	"seconds",
	RTOffsetOf( RTTime, seconds ),
	&RTType_RTInteger,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTTime::classData =
{
    &RTType_RTSequence,
    (RTSuperAccessFunction)_access,
    "RTTime",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTTime ),
    _init,
    _copy,
#if OBJECT_DECODE
    RTstruct_decode,
#endif
#if OBJECT_ENCODE
    RTstruct_encode,
#endif
    RTDataObject_destroy,
    3, RTTime::fieldData
};

#if OBJECT_DECODE
RTTypeInstaller RTTime_installer( RTType_RTTime );
#endif

const RTObject_class * RTTime::getClassData( void ) const
{
    return &RTTime::classData;
}
