/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTSpecialSignals.h>
#include <RTTimerActor.h>
#include <RTTimerNode.h>

void RTTimerActor::adjustTimeEnd( const RTTimespec & delta,
				  RTController     * originator )
{
    currentOffset += delta;

#if USE_THREADS
    RTTimerNode::critical.leave();
#endif

    if( delta > RTTimespec::zero ) //lint !e909
	(void)originator->send( this, RTWakeupSignal,
				      (const void *)0,
				      (const RTObject_class *)0, System );
}
