/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTToolsetObserver.h>

void RTToolsetObserver::handleState( void )
{
    TO_stateInfo * myStateInfo = (TO_stateInfo *)structInfo.ptr;
    RTDaemonInfo * daemonInfo  = new RTDaemonInfo;

    daemonInfo->setInfoState( myStateInfo->actor, myStateInfo->state );

    if( structInfo.func == CMD_ADD_STATE )
    {
	int probeNr = addInfo( daemonInfo );
	if( probeNr >= 0 )
	{
	    sendResultCode( RES_OK );
	    debugger->getPresence( probeNr,
				   observerId,
				   structInfo.daemon.number );
	    debugger->getHistory( probeNr, daemonInfo->stateTarget );
	}
	else
	{
	    sendResultCode( RES_BAD_STATE );
	    delete daemonInfo;
	}
    }
    else // structInfo.func == CMD_DEL_STATE
    {
	if( delInfo( daemonInfo ) <= 0 ) // number of actors deleted
	    sendResultCode( RES_BAD_STATE );
	else
	    sendResultCode( RES_OK );

	delete daemonInfo;
    }
}
