/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTProbe_h__
#define __RTProbe_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTActor;
class RTDebugger;

class RTProbe
{
public:
    virtual                 ~RTProbe( void );

    RTS_INLINE int          adjustRefCount( int offset );
    RTS_INLINE const char * getStringPath( void ) const;
    RTS_INLINE int          getActorIndex( void ) const;

    virtual int             connectProbe   ( void );
    virtual int             disconnectProbe( RTActor * actor );

    RTS_INLINE int          getProbeId( void ) const;
    virtual const char    * getTypeStr( void ) const = 0;

    int                     breakPointAction( void );
    int                     showProbe( void );
    RTS_INLINE int          cmdline( void ) const;
    RTS_INLINE int          connected( void ) const;
    RTS_INLINE RTActor    * actor( void ) const;

protected:
			    RTProbe( RTDebugger * debugger,
				     int          id,
				     const char * strPath,
				     int          actorIndex );

    RTDebugger            * _debugger;
    int                     _id;
    int                     _owner;
    RTActor               * _actor;
    int                     _doReport;
    int                     _refCount;
    char                  * _stringPath;
    int                     _actorIndex;

public:
    int                     _destroyMe;

private:
    // unavailable methods
    RTProbe( const RTProbe & );
    RTProbe & operator=( const RTProbe & );
}; //lint !e1712

#if RTS_INLINES
#include <RTProbe.inl>
#endif

#endif // __RTProbe_h__
