/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSuperActor_h__
#define __RTSuperActor_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActor_h__
#include <RTActor.h>
#endif

#ifndef __RTActorRef_h__
#include <RTActorRef.h>
#endif

#ifndef __RTFrame_h__
#include <RTFrame.h>
#endif

#ifndef __RTTiming_h__
#include <RTTiming.h>
#endif

class RTController;
class RTThread;

class RTSuperActor : public RTActor
{
public:
    explicit                            RTSuperActor( RTController * );
    virtual                             ~RTSuperActor( void );

    virtual void                        rtsBehavior( int, int );
    virtual const RTActor_class       * getActorData( void ) const;

protected:
    RTActorRef                          specials;
    RTActorRef                          application;
    Frame::Base                         frame;
    Timing::Base                        timer;

#if USE_THREADS
    RTController                      * timerController;
    RTThread                          * timerThread;
#endif

    void                                t1_initialize( void );
    void                                t2_start( void );

    enum { rtid_frame = 1, rtid_timer };

    static  const RTActor_class        rtg_class;

private:
    static const RTComponentDescriptor rtg_capsule_roles[];
#if USE_THREADS
    static const RTFieldDescriptor     rtg_fields[];
#endif
    static const RTStateId             rtg_parent_state[];
    static const RTPortDescriptor      rtg_ports[];

    // unavailable methods
    RTSuperActor & operator=( const RTSuperActor & );
    RTSuperActor( const RTSuperActor & );
}; //lint !e1712

#endif // __RTSuperActor_h__
