/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTtcp_h__
#define __RTtcp_h__ included

#include <windows.h>
#include <winsock.h>

typedef struct sockaddr SocketAddress;
typedef int             SocketAddressSize;

#define INET_HaveLength 0

#define INET_accept( sock, addr, port ) \
			 ( (int)accept( (SOCKET)(sock), (addr), (port) ) )

#define INET_bind( sock, addr, size ) \
			 ( bind( (SOCKET)(sock), (addr), (size) ) )

#define INET_close( sock ) \
			 ( closesocket( (SOCKET)(sock) ) )

#define INET_connect( sock, addr, size ) \
			 ( connect( (SOCKET)(sock), (addr), (size) ) )

#define INET_error( sock ) \
			 WSAGetLastError()

#define INET_getsockname( sock, addr, size ) \
			 ( getsockname( (SOCKET)(sock), (addr), (size) ) )

#define INET_ioctl( sock, cmd, arg )                          \
			 ioctlsocket( (SOCKET)(sock), (cmd),  \
				      (unsigned long *)(arg) )
#define INET_listen( sock, backlog ) \
			 ( listen( (SOCKET)(sock), (backlog) ) )

#define INET_lookup      gethostbyname

#define INET_recv( sock, addr, size, flags ) \
			 ( recv( (SOCKET)(sock), (addr), (size), (flags) ) )

#define INET_recvfrom( sock, buf, size, flags, src, src_len ) \
			 ( recvfrom( (SOCKET)(sock), (buf), (size), (flags), \
				     (src), (src_len) ) )

#define INET_send( sock, addr, size, flags ) \
			 ( send( (SOCKET)(sock), (addr), (size), (flags) ) )

#define INET_sendto( sock, buf, size, flags, dst, dst_len ) \
			 ( sendto( (SOCKET)(sock), (buf), (size), (flags), \
				   (dst), (dst_len) ) )

#define INET_setsockopt( sock, level, cmd, value, size ) \
			 ( setsockopt( (SOCKET)(sock),   \
				       (level),          \
				       (cmd),            \
				       (value),          \
				       (size) ) )

#define INET_socket( domain, type, protocol ) \
			 ( (int)socket( (domain), (type), (protocol) ) )

#define INET_EALREADY    WSAEALREADY
#define INET_EINPROGRESS WSAEINPROGRESS
#define INET_EINTR       WSAEINTR
#define INET_EISCONN     WSAEISCONN
#define INET_EWOULDBLOCK WSAEWOULDBLOCK

// Microsoft says this shouldn't happen when we specify WSA_FLAG_OVERLAPPED,
// but it does anyway!
#define INET_EMAYBECONN  WSAEINVAL

#endif // __RTtcp_h__
