/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" struct uport * uportlist[];

extern "C" int RTinet_bind( int                    sock,
			    const RTinet_address * address,
			    RTinet_port            port )
{
    if( port == 0 )
    {
	const RTinet_port port_min   =  1024U;
	const RTinet_port port_first = 20000U;
	const RTinet_port port_max   = 32767U;

	port = port_first;

	for( int i = 0; i < NUPORTS; ++i )
	{
	    if( uportlist[ i ] == NU_NULL )
	    {
		// skip empty slots
	    }
	    else if( uportlist[ i ]->up_lport == intswap( port ) )
	    {
		// this port number is in use try another
		if( port == port_max )
		    port = port_min;
		else
		    ++port;

		if( port == port_first )
		    return 0; // we tried them all

		i = -1;
	    }
	}
    }

    addr_struct addr;

    RTMemoryUtil::memset( &addr, 0, (int)sizeof( addr ) );

    addr.family = NU_FAMILY_IP;
    addr.port   = port;

    if( address != (const RTinet_address *)0 )
	RTMemoryUtil::memcpy( &addr.id, address, (int)sizeof( *address ) );

    return NU_Bind( sock, &addr, 0 ) >= 0;
}
