/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTMutex.h>

#include <psos.h>

RTMutex::RTMutex( void )
{
#if TARGET_PSOS >= 25 // mutex support available
    if( mu_create( (char *)0,
		   MU_LOCAL | MU_PRIOR | MU_PRIO_INHERIT | MU_NORECURSIVE,
		   0UL, // priority ceiling (ignored)
		   &mutex ) != 0UL )
	RTDiag::panic( "mu_create" );
#else
    if( sm_create( (char *)0, 1UL, SM_LOCAL | SM_PRIOR, &mutex ) != 0UL )
	RTDiag::panic( "sm_create" );
#endif
}
