/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>
#include <RTTimespec.h>

#include <psos.h>
#include <configs.h>

extern "C" NodeConfigTable * anchor;

static int  initialized   = 0;
static long nsec_per_tick;

void RTSyncObject::timedwait( const RTTimespec & expireTime )
{
    if( ! initialized )
    {
	nsec_per_tick = 1000000000 / anchor->psosct->kc_ticks2sec;
	initialized  = 1;
    }

    long          delta;
    unsigned long events;

    if( (delta = expireTime.ticksFromNow( nsec_per_tick )) > 0 )
    {
	switch( ev_receive( WakeupEvent, EV_WAIT | EV_ANY, delta, &events ) )
	{
	    case 0:
	    case ERR_TIMEOUT:
		break;
	    default:
		RTDiag::panic( "ev_receive(timed)" );
		//lint -unreachable
		break;
	}
    }
}
